# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free

Summary:        Report-generating tool
Name:           jasperreports
Version:        1.0.3
Release:        3jpp
Epoch:          0
License:        Apache-style Software License & LGPL
URL:            http://jasperreports.sourceforge.net/
Group:          Text Processing/Markup/XML
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        %{name}-%{version}-project.zip
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  java-devel >= 0:1.4
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  junit
BuildRequires:  ecj
BuildRequires:  hsqldb
BuildRequires:  itext
BuildRequires:  jakarta-commons-beanutils 
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-digester
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-poi
BuildRequires:  jcommon0
BuildRequires:  jfreechart0
BuildRequires:  servletapi4
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Requires:       java >= 0:1.4
Requires:       ecj
Requires:       hsqldb
Requires:       itext
Requires:       jakarta-commons-beanutils
Requires:       jakarta-commons-collections
Requires:       jakarta-commons-digester
Requires:       jakarta-commons-logging
Requires:       jakarta-poi
Requires:       jcommon0
Requires:       jfreechart0
Requires:       servlet
Requires:       xalan-j2
Requires:       xerces-j2
Requires:       xml-commons-apis
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
%if %{gcj_support}
BuildRequires:    gnu-crypto
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
JasperReports is a powerful open source 
report-generating tool that has the ability 
to deliver rich content onto the screen, to 
the printer or into PDF, HTML, XLS, CSV and 
XML files. It is entirely written in Java 
and can be used in a variety of Java enabled 
applications, including J2EE or Web 
Its main purpose is to help creating page 
oriented, ready to print documents in a 
simple and flexible manner. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%package demo
Summary:        Samples for %{name}
Group:          Development/Documentation

%description demo
%{summary}.

%prep
%setup -q -T -c -n %{name}-%{version}
cd ..
unzip -q %{SOURCE0}
cd %{name}-%{version}
#find . -name "*.class" -exec rm {} \;
#find . -name "*.jar" -exec rm {} \;
for j in $(find . -name "*.jar"); do
        mv $j $j.no
done

%build
export OPT_JAR_LIST="ant/ant-junit junit"
pushd lib
ln -sf $(build-classpath commons-beanutils)
ln -sf $(build-classpath commons-collections)
ln -sf $(build-classpath commons-digester)
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath commons-logging-api)
ln -sf $(build-classpath hsqldb)
ln -sf $(build-classpath itext)
ln -sf $(build-classpath jcommon0)
ln -sf $(build-classpath ecj)
ln -sf $(build-classpath jfreechart0)
ln -sf $(build-classpath poi)
ln -sf $(build-classpath servletapi4)
ln -sf $(build-classpath xalan-j2)
ln -sf $(build-classpath xerces-j2)
ln -sf $(build-classpath xml-commons-apis)
popd
ant jar docs

cat > demo/samples/webapp/applets/PUT.jasperreports-applet.jar.HERE.txt << EOT
Copy or symlink the jasperreports-applet-1.0.0.jar to this location.
EOT

cat > demo/samples/webapp/WEB-INF/lib/PUT.required.jars.HERE.txt << EOT
Copy or symlink the bsh.jar to this location.
Copy or symlink the commons-beanutils.jar to this location.
Copy or symlink the commons-collections.jar to this location.
Copy or symlink the commons-digester.jar to this location.
Copy or symlink the commons-logging.jar to this location.
Copy or symlink the itext.jar to this location.
Copy or symlink the jasperreports-1.0.0.jar to this location.
EOT

cat > demo/samples/jcharts/GET.jCharts-0.6.0.jar.HERE.txt << EOT
Get and copy or symlink jCharts-0.6.0.jar to this location.
EOT

cat > demo/samples/jfreechart/PUT.jfreechart.jar.HERE.txt << EOT
Copy or symlink the jfreechart.jar (from jfreechart-0.9.21-1jpp) to this location.
Copy or symlink the jcommon.jar (from jcommon-0.9.7-1jpp) to this location.
EOT


%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p dist/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p dist/%{name}-%{version}-applet.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-applet-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf docs/api

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p lgpl.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# demo
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr demo/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
find $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version} -name "*.jar.no" -exec rm -f {} \;

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm --exclude /usr/share/java/%{name}-applet-%{version}.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/lgpl.txt
%{_javadir}/*.jar
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%files demo
%defattr(0644,root,root,0755)
%doc %{_datadir}/%{name}-%{version}

%changelog
* Thu Mar 22 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0.3-3jpp
- (B)R jfreechart0 instead of jfreechart
- (B)R ecj instead of eclipse-jdt, use %{_javadir}/ecj.jar, not jdtcore
- Add gcj_support option

* Mon Feb 27 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0.3-2jpp
- Minor fixes to upload to 1.7/free

* Fri Feb 24 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0.3-1jpp
- Upgrade to 1.0.3

* Tue Sep 20 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0.2-1jpp
- Upgrade to 1.0.2

* Tue Sep 20 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0.0-1jpp
- Upgrade to 1.0.0
- Relax some versioned dependencies

* Wed Feb 16 2005 Ralph Apel <r.apel at r-apel.de> - 0:0.6.4-1jpp
- Upgrade to 0.6.4 (thx to Joe Wortmann)

* Tue Dec 14 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.6.2-1jpp
- Upgrade to 0.6.2

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:0.5.2-3jpp
- Rebuild with ant-1.6.2

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:0.5.2-2jpp
- Upgrade to Ant 1.6.X

* Fri Feb 27 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.5.2-1jpp
- First JPackage release
